#
/*
 *		M U L T I - D E V I C E   Q U E U E I N G   S Y S T E M
 *
 *				   M S G O P E N . C
 *
 *				Douglas P. Kingston III
 *
 *				    Revision History
 *				    ================
 *	SOC Version 1.0	12/21/82	David A. Wilson, BAC
 *			Fix usage of mail(1) so subject line is written
 *			to mail(1) after pipe is opened.
 *	12 Aug 83  DPK	Added "Re: " line with request and title
 */

#include <stdio.h>
#include "queue.h"
#include "rawreq.h"

extern char *MDQSuser;
char	*index();
char	*strdup();
FILE	*procopen();

FILE *
msgopen( rp )
register struct request *rp;
{
	char	cmdbuf[LINESIZ];
	char	linebuf[LINESIZ];
	char	*source = 0;
	char	*title = 0;
	register char	*cp;
	register FILE	*pf;

	if(( rp->r_options & O_MAIL) == 0 )
		return( NULL );

	if(( pf = fopen (rp->r_name, "r")) == NULL) {
		complain ("Error trying to notify, %s: %s",
			  rp->r_name, sys_errlist[errno]);
		return( NULL );
	}
	fseek (pf, (long) sizeof (struct rawrequest), 0);
	while (fgets (linebuf, LINESIZ, pf) != NULL ) {
		if (cp = index (linebuf, '\n'))
			*cp = 0;
		switch (linebuf[0]) {
		case 'T':
			if( title == 0 )
				title = strdup( &linebuf[1] );
			break;
		case 'U':
			if( source == 0 )
				source = strdup( &linebuf[1] );
			break;
		}
		if( source && title )
			break;
	}
	fclose (pf);
	if( source == 0 ) {
		complain( "Bad user line '%s' in %s", source, rp->r_name );
		if( title )
			free( title );
		return( NULL );
	}
	sprintf( cmdbuf, "mail '%s'", source );

	/*
	 *  Can't use the regular popen(3) because pclose does
	 *  wait(2)'s which are a no-no in a program that needs
	 *  to know about all its children!
	 */
	if ((pf = procopen (cmdbuf, "w")) == NULL) {
		complain ("Error trying to notify %s (%s)\nmail: %s",
			  source, rp->r_name, sys_errlist[errno]);
	}
	else
	{
		/* send subject line */
		fprintf( pf, "Subject: MDQS Notification (%s)\n", rp->r_que );
		fprintf( pf, "\nRe: Request %s (file %s)\n\n", rp->r_name,
				title ? title : "-unknown-" );
	}
	free( source );
	if( title )
		free( title );
	return( pf );
}

