static char	rcsid[] = "$Source$$Revision$";
/*  vplotn ---
 *	reads raster file created by vplot and dumps it onto the
 *	Versatec plotter.
 */
#include <stdio.h>
#include <signal.h>
#include "vp.h"

#define VAX	1	/* Machine Flag (don't simulate VM on vax) */
#define TEST2	1
#define	VERSATEC_V80_211	1	/* we have this one */

#define BSIZ	512		/* Size of blocks */
#define IO_BSIZ	16*512		/* # of blocks to read/write for rasterdmp */

#ifdef VERSATEC_V80_211
#define BYTES_PER_LINE	264	/* # of bytes per raster line of versatec */
#define RASTERSIZE	BYTES_PER_LINE*8	/* # bits per raster line */
#define TOTALBLOCKS	(BYTES_PER_LINE*RASTERSIZE/BSIZ)+1
#endif

#ifdef VAX
#define NB	TOTALBLOCKS	/* Number of blocks in virtual memory */
#else
	NB	88		/* Number of blocks kept in memory */
#endif
#define	onintr()	doflush()

#ifndef	TEST2
typedef struct	buf
{
	int	bno;
	char	*block;
};
char	blocks	[NB][BSIZ];
#ifndef	VAX
struct	buf	bufs[NB];
#endif

int	obuf[220*64];		/* output buffer; 64 lines of output */
#else TEST2
char	obuf[IO_BSIZ];	/* output buffer */
#endif TEST2

/* set in vcopyn.c */
extern int	vpltmode[];
extern int	vprtmode[];

int	vformfeed[]	= ffcom;	/* form feed command */
#define FORMFEED	/* fanfold paper */

long	lines = 0L;

long
vplotn( df, llimit )
FILE	*df;		/* vplot raster input file */
long	llimit;		/* line limit */
{
	int	in, vfd;
#ifndef TEST2
	register x, *ip, *op;
	int i,y;
#else TEST2
	int	nbytes;

#endif TEST2

	in = fileno( df );
	vfd = fileno( stdout );
	fflush( stdout );
	ioctl( vfd, SETSTATE, vpltmode );
	lseek( in, 0L, 0);
#ifndef TEST2
	for (i=0; i<32; i++)
	{
		read( in, blocks[0], 32*BSIZ);
		for (y=0; y<64; y++)
		{
			op = &(obuf[(y*BYTES_PER_LINE)/4]);
			for (x=0; x<32; x++) 
			{
				ip = (int *)&blocks[x][y<<3];
				*op++ = *ip++;
				*op++ = *ip++;
			}
		}
		write( vfd, (char *)obuf, BYTES_PER_LINE*64);
	}
#else TEST2
	while ( ( nbytes=read( in, obuf, IO_BSIZ )) > 0 )
	{
		write( vfd, obuf, nbytes );
	}
#endif TEST2
	ioctl( vfd, SETSTATE, vprtmode );
	ioctl( vfd, SETSTATE, vformfeed );
	return ( lines );
}
